/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{

	using namespace std;

	class ICFS_t : virtual public InstructionSet_t, virtual public BaseObj_t
	{
		protected:
			ICFS_t() {};
			ICFS_t(const ICFS_t& copy) = delete;
		public:
			 
			// getters
			virtual bool                 isIncomplete()      const = 0;
			virtual bool                 isComplete()        const = 0;
			virtual bool                 isModuleComplete()  const = 0;
			virtual ICFSAnalysisStatus_t getAnalysisStatus() const = 0;

			// mutators
			virtual void setTargets(const InstructionSet_t &other)              = 0;
			virtual void addTargets(const InstructionSet_t &other)              = 0;
			virtual void setAnalysisStatus(const ICFSAnalysisStatus_t p_status) = 0;

	};

}
